## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 4;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global debug_package %{nil}

Name:       jujutsu
Version:    0.25.0
Release:    %autorelease
Summary:    A Git-compatible DVCS that is both simple and powerful

License:    MIT
URL:        https://github.com/martinvonz/jj
Source0:    %{url}/archive/refs/tags/v%{version}.tar.gz

BuildRequires: cargo
BuildRequires: rust
BuildRequires: gcc
BuildRequires: git-core
BuildRequires: python3-devel
BuildRequires: openssl-devel
BuildRequires: pkgconf-pkg-config

BuildRequires: pkgconfig(openssl)
BuildRequires: pkgconfig(x11)
BuildRequires: pkgconfig(xcb)
BuildRequires: pkgconfig(zlib)

%description
Jujutsu is a Git-compatible DVCS. It combines features from Git (data model,
speed), Mercurial (anonymous branching, simple CLI free from "the index",
revsets, powerful history-rewriting), and Pijul/Darcs (first-class conflicts),
with features not found in most of them (working-copy-as-a-commit, undo
functionality, automatic rebase, safe replication via rsync, Dropbox, or
distributed file system).

%prep
%autosetup -n jj-%{version}

# Change default optimizations
sed -i '/profile.release/d' Cargo.toml
sed -i '/strip = "debuginfo"/d' Cargo.toml
sed -i '/codegen-units = 1/d' Cargo.toml

echo -e '\n[profile.release]' >> Cargo.toml
echo 'opt-level = 3' >> Cargo.toml
echo 'strip = true' >> Cargo.toml
echo 'lto = true' >> Cargo.toml
echo 'codegen-units = 1' >> Cargo.toml

%if 0%{?el8} || 0%{?el9}
  curl https://sh.rustup.rs -sSf | sh -s -- --profile minimal -y
%endif


%install
# export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=3
%if 0%{?el8} || 0%{?el9}
source "$HOME/.cargo/env"
%endif
cargo install --locked --root=%{buildroot}%{_prefix} --bin jj jj-cli


rm -f %{buildroot}%{_prefix}/.crates.toml \
    %{buildroot}%{_prefix}/.crates2.json
strip --strip-all %{buildroot}%{_bindir}/*


%files
%license LICENSE
%doc README.md
%{_bindir}/jj

%changelog
## START: Generated by rpmautospec
* Sat Jan 04 2025 Taylor C. Richberger <taylor@axfive.net> - 0.25.0-4
- fix changelog

* Sat Jan 04 2025 Taylor C. Richberger <taylor@axfive.net> - 0.25.0-3
- switch to autorelease and autochangelog

* Sat Jan 04 2025 Taylor C. Richberger <taylor@axfive.net> - 0.25.0-2
- remove debug package symbols

* Sat Jan 04 2025 Taylor C. Richberger <taylor@axfive.net> - 0.25.0-1
- version bump

* Sat Jan 04 2025 Taylor C. Richberger <taylor@axfive.net> - 0.14.0-3
- update email address

* Thu Feb 08 2024 Taylor C. Richberger <taywee@gmx.com> - 0.14.0-2
- fix cargo install command

* Thu Feb 08 2024 Taylor C. Richberger <taywee@gmx.com> - 0.14.0-1
- version bump

* Tue Aug 08 2023 Taylor C. Richberger <taywee@gmx.com> - 0.8.0-2
- try to fix packaging for the 5th time

* Tue Aug 08 2023 Taylor C. Richberger <taywee@gmx.com> - 0.8.0-1
- move jujutsu stuff into base dcirectory, and change opt-level to be an
  integer
## END: Generated by rpmautospec
